/**
 * 
 */	

(function() {
	if(!window.azumio){
		window.azumio = {};
	}
	
	if(!window.azumio.localStorage){
		if(window.azumioLocalStorage){
			window.azumio.localStorage = azumioLocalStorage;
		}else{
			window.azumio.localStorage = localStorage;
		}
	}

	if(!window.azumio.auth){
		window.azumio.auth = {};
	}
	var a = window.azumio.auth;

	a.requestOAuthToken = function(obj) {
		azumio.jsonGet("/v1/token",{
			success: function(data){
				a.setOAuthToken(data.access_token);
				if(obj.success){
					obj.success(data);
				}
			},
			error: obj.error,
			complete: obj.complete,
			data: obj.data
		});
	}
	
	var _accessTokenStorageKey = 'com.azumio.auth.access_token';
	
	a.logout = function(){

		azumio.localStorage.removeItem(_accessTokenStorageKey);
		azumio.localStorage.removeItem('oauth_token');
		
		$(window).trigger("azumio.auth.logout");
		azumio.trigger("azumio.auth.logout");
	}
	
	a.setOAuthToken = function(token){
		if( !token  ){
			a.logout();
			return; 
		}
		
		azumio.localStorage.setItem(_accessTokenStorageKey, token);
		
		$(window).trigger("azumio.auth.login",token);
		azumio.trigger("azumio.auth.login",token);
	}
	
	a.getOAuthToken = function(token){
		var token = null;
		
		if( azumio.localStorage.getItem(_accessTokenStorageKey) != null ){
			token = azumio.localStorage.getItem(_accessTokenStorageKey);
		}else if( azumio.localStorage.getItem('oauth_token') != null ){
			token = azumio.localStorage.getItem('oauth_token');
		}
		
		return token;
	}
	
	a.showLogin = function(){
		//azumio.openWindow(azumio.settings.apidomain + "/authorize/mobileui?redirect_uri=/mobileui/loginhandler.jsp",azumio.onLoginWindowClose);
		azumio.trigger("azumio.auth.requestLogin");
	}
	
	a.isAuthenticated = function(){
		var token = a.getOAuthToken();
		return token != null;
	}
	

})();




